import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;

/**
 * represente la visualisation graphique des tags du document 
 */
 
public class ListeTagIhm extends JScrollPane
{
class Couple
{
String _balise;
String _texte;
}
class MyCellRenderer extends JPanel implements ListCellRenderer {
      ImageIcon longIcon ;
     ImageIcon shortIcon ;
	JLabel un;
	JLabel deux;
	Font _font1;
	Font _font2;
     // This is the only method defined by ListCellRenderer.
     // We just reconfigure the JLabel each time we're called.
     public MyCellRenderer(String font1,String font2)
     {
     super(new FlowLayout(FlowLayout.LEFT,
          0,0));
        if (font1!=null && font2!=null){
_font1=new Font(font1,Font.PLAIN,10);
_font2=new Font(font2,Font.PLAIN,10);}
          setForeground(Color.white);
          setBackground(Color.white);
     longIcon = new ImageIcon("file_new.gif");
      shortIcon = new ImageIcon("file_save.gif");
   /*   StyleContext m_context = new StyleContext();
    DefaultStyledDocument m_doc = new DefaultStyledDocument(m_context);
      StyledEditorKit m_kit = new StyledEditorKit();
  	setEditorKit(m_kit);
	
   	setDocument(m_doc);*/
   	un=new JLabel(/*LEFT*/);
   	deux=new JLabel(/*LEFT*/);
   	}
     public Component getListCellRendererComponent(
       JList list,
       Object value,            // value to display
       int index,               // cell index
       boolean isSelected,      // is the cell selected
       boolean cellHasFocus)    // the list and the cell have the focus
     {
         Couple s=(Couple)value;
         
         un.setText(s._balise);
         if (_font1!=null) un.setFont(_font1);
         
         add(un);
         
         deux.setText(s._texte);
         if (_font2!=null) un.setFont(_font2);
         add(deux);
         
      /*  System.err.println("1");
        
   	StyledDocument m_doc2=getStyledDocument();
   	System.err.println("1");
   	SimpleAttributeSet a1=new SimpleAttributeSet();
        System.err.println("2");
        StyleConstants.setItalic(a1, true) ;
        System.err.println("3");
        SimpleAttributeSet a2=new SimpleAttributeSet();
   	String aff=s._balise;
   	if (s._texte!=null) aff=aff+s._texte;
   	try{
	System.err.println("4");
	m_doc2.insertString(0,aff,new SimpleAttributeSet() );
   	}catch (Exception bv){System.out.println(bv);}
   	System.err.println("5");
   	m_doc2.setCharacterAttributes(0,s._balise.length(),a1,true);
        System.err.println("6");
        if (s._texte!=null) m_doc2.setCharacterAttributes(s._balise.length(),s._balise.length()+s._texte.length(),a2,true);
         System.err.println("7");*/
         return this;
     }
 }

/**
 * la fenetre mere
 */
protected MainFrame _master;
/**
 * la liste graphique 
 */
protected JList _liste;
/**
 * la liste des tag
 */
protected ListeTag _tag;
protected BaliseNode [] _bnode;
protected boolean _both ;
String _mfont1;
String _mfont2;
public void setBoth(boolean both) {_both=both;}
public void setFont1(String font1){_mfont1=font1;}
public void setFont2(String font2){_mfont2=font2;}
/**
 * constructeur de la classe , on passe la fenetre mere en parametre
 */
public ListeTagIhm(MainFrame master)
{
super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
setSize(600, 400);
_master=master;
_liste=new JList();
getViewport().setView(_liste);
_both=false;
setVisible(true);
}
/**
 * mets a jour le composant avec une liste de tag
 */
public void SetTag(ListeTag tag,String document)
{
XmlNode xmlnode=new XmlNode();
xmlnode.Init(tag);
_bnode=xmlnode.getNode();

_liste=null;
_tag=tag;
Vector test=new Vector(10,10);
int decal=0;
BaliseNode work;
for (int i=0;i<_bnode.length;i++)
 {Couple couple=new Couple();
   String affiche=new String();
 	
 	work=_bnode[i];
 	if (work.IsDebut())
 	{
 	decal=decal+2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getDebutStringBalise();
 	int taille=work.getTag().getFin()-work.getTag().getDebut();
 	if (taille>20) taille=20;
 	/* TODO verifier la taille max */
 	couple._balise=new String(affiche);
 	couple._texte=(document.substring(work.getTag().getDebut(),work.getTag().getDebut()+taille)).replace('\n',' ');
 	affiche=affiche+(document.substring(work.getTag().getDebut(),work.getTag().getDebut()+taille)).replace('\n',' ');
 	test.add(couple);
 	}
	else
	{if (!_both){
	decal=decal-2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getFinStringBalise();
	couple._balise=new String(affiche);test.add(couple);}
}

}
_liste=new JList(test);
_liste.setCellRenderer(new MyCellRenderer(_mfont1,_mfont2));
getViewport().setView(_liste);
setVisible(true);

MouseListener mouseListener = new MouseAdapter() {
     public void mouseClicked(MouseEvent e) {
     try{  
             int index = _liste.locationToIndex(e.getPoint());
             if (!_both) index=index*2;
             Tag t;
             if (_bnode[index].IsDebut()) t=_bnode[index].getTag();
             	else t=_bnode[index].getSoeur().getTag();
             System.out.println("Double clicked on Item " + index);
             ListeTagIhm.this._master.select(t);
             ListeTagIhm.this._master.viewLigne(t.getLigne());
     } catch (Exception ve) {System.out.println(ve);}; 
     }
 };
 _liste.addMouseListener(mouseListener);
 
repaint();
}/*
public void SetTag(String document,ListeTag tag, String dtdfile)
{
XmlNode xmlnode=new XmlNode();
xmlnode.Init(tag);
_bnode=xmlnode.getNode();

_liste=null;
_tag=tag;
Vector test=new Vector(10,10);
int decal=0;
BaliseNode work;
for (int i=0;i<_bnode.length;i++)
 {String affiche=new String();

 	
 	work=_bnode[i];
 	if (work.IsDebut())
 	{
 	decal=decal+2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getDebutStringBalise();
 	int taille=work.getTag().getDebut()-work.getTag().getFin();
 	if (taille>20) taille=20;
 	affiche=affiche+document.substring(work.getTag().getDebut(),taille);
 	}
	else
	{
	decal=decal-2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getFinStringBalise();
	
}
test.add(affiche);
 }
_liste=new JList(test);
getViewport().setView(_liste);
setVisible(true);

MouseListener mouseListener = new MouseAdapter() {
     public void mouseClicked(MouseEvent e) {
     try{  
             int index = _liste.locationToIndex(e.getPoint());
             Tag t;
             if (_bnode[index].IsDebut()) t=_bnode[index].getTag();
             	else t=_bnode[index].getSoeur().getTag();
             System.out.println("Double clicked on Item " + index);
             ListeTagIhm.this._master.select(t);
             ListeTagIhm.this._master.viewLigne(t.getLigne());
     } catch (Exception ve) {System.out.println(ve);}; 
     }
 };
 _liste.addMouseListener(mouseListener);
 
repaint();
}*/
public void select (Tag t)
{
for (int i=0;i<_bnode.length;i++)
{
if (_bnode[i].getTag().equals(t)) {_liste.setSelectedIndex(i);
int max_ligne=_liste.getLastVisibleIndex();
JScrollBar _scroll=getVerticalScrollBar();
  if (_scroll==null) return;
  int max=_scroll.getMaximum();
  int nvalue=(i*max)/max_ligne;
  
  _scroll.setValue(nvalue);
return;}
}        
}

}
