import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
/** 
 * PreferenceDialog permet de choisir les attribut graphiques
*/ 
public class PreferenceDialog extends JDialog implements WindowListener ,DocumentBaliseName
{

 
  protected MutableAttributeSet m_attributes;
  
  protected JComboBox m_cbColorDefaultXML;
  protected JCheckBox m_chkBoldDefaultXML;
  protected JCheckBox m_chkItalicDefaultXML;
  protected JCheckBox m_chkUnderlineDefaultXML;
  protected OpenList m_lstFontNameDefaultXML;
  
  
  protected JComboBox m_cbColorDefaultText;
  protected JCheckBox m_chkBoldDefaultText;
  protected JCheckBox m_chkItalicDefaultText;
  protected JCheckBox m_chkUnderlineDefaultText;
  protected OpenList m_lstFontNameDefaultTreeText;
  protected OpenList m_lstFontNameDefaultTreeXml;
  protected JCheckBox endingbalise;
    
  protected OpenList m_lstFontNameTreeViewText;
  protected OpenList m_lstFontNameTreeViewXML;
  protected   JTextField dtdfile;
  protected JTextField defaultcolor;
  protected int m_option = JOptionPane.CLOSED_OPTION;
 
  protected MainFrame _master;
  protected JPanel CreatePreferenceColor()
  {
 JPanel front_color_panel = new JPanel();
 front_color_panel.setBorder(new TitledBorder(new EtchedBorder(), "Color"));
    front_color_panel.setLayout(new GridLayout(2,2));
   // p.add(Box.createHorizontalStrut(10));
    front_color_panel.add(new JLabel("Front Color:"));
   // p.add(Box.createHorizontalStrut(20));
   JComboBox m_cbColor = new JComboBox();
    int[] values = new int[] { 0, 128, 192, 255 };
    for (int r=0; r<values.length; r++) 
    {
      for (int g=0; g<values.length; g++) 
      {
        for (int b=0; b<values.length; b++) 
        {
          Color c = new Color(values[r], values[g], values[b]);
          m_cbColor.addItem(c);
        }
      }
    }
  
   m_cbColor.setRenderer(new ColorComboRenderer());
    front_color_panel.add(m_cbColor);
    return front_color_panel;
  }
  public PreferenceDialog(MainFrame master, 
    String[] names)
   
   {
   _master=master;
   
   getContentPane().setLayout(new BoxLayout(getContentPane(), 
      BoxLayout.Y_AXIS));
    // JPanel ppp=new JPanel(new GridLayout(2, 1, 10, 2));
  
    JPanel font_panel=new JPanel(new GridLayout(1, 2, 10, 2));
    JPanel attribut_panel = new JPanel(new GridLayout(1, 2, 10, 2));
    JPanel font_balise_panel=new JPanel (new GridLayout(1,1,10,2));
    JPanel attribut_liste=new JPanel(new GridLayout(3,1,10,5));
    
    font_balise_panel.setBorder(new TitledBorder(new EtchedBorder(), "Modify Balise Default Style"));
    m_lstFontNameDefaultXML = new OpenList(names, "Font Name:",2);
    font_balise_panel.add(m_lstFontNameDefaultXML); 
    
     JPanel attribut_balise_panel = new JPanel(new GridLayout(3, 1, 10, 5));
    attribut_balise_panel.setBorder(new TitledBorder(new EtchedBorder(), "Default Balise Xml Property"));
    m_chkBoldDefaultXML = new JCheckBox("Bold");
    attribut_balise_panel.add(m_chkBoldDefaultXML);
    m_chkItalicDefaultXML = new JCheckBox("Italic");
    attribut_balise_panel.add(m_chkItalicDefaultXML);
    m_chkUnderlineDefaultXML = new JCheckBox("Underline");
    attribut_balise_panel.add(m_chkUnderlineDefaultXML);
      
      JPanel attribut_tree=new JPanel(new GridLayout(3,1,10,5));
       attribut_tree.setBorder(new TitledBorder(new EtchedBorder(), "Modify Tree Style"));
    m_lstFontNameDefaultTreeXml = new OpenList(names, " Balise Font Name:",2);
    m_lstFontNameDefaultTreeText=new OpenList(names, " Text Font Name:",2);
    attribut_tree.add(m_lstFontNameDefaultTreeText);
    attribut_tree.add(m_lstFontNameDefaultTreeXml);
     endingbalise = new JCheckBox("Show Ending Balise");
     attribut_tree.add(endingbalise);
     
     JLabel label_dtd=new JLabel("Default DTD Filename :");
     JLabel label_color=new JLabel("Default Color Filename :");
      dtdfile=new JTextField();
      defaultcolor=new JTextField();
     
     JPanel filename_default = new JPanel(new GridLayout(2, 2, 10, 5));
     filename_default.setBorder(new TitledBorder(new EtchedBorder(), "nom de fichier par defaut"));
   
     filename_default.add(label_dtd);
     filename_default.add(dtdfile);
     filename_default.add(label_color);
     filename_default.add(defaultcolor);
     
    
    font_panel.add(font_balise_panel);
attribut_panel.add(attribut_balise_panel);
attribut_panel.add(attribut_tree);

 

    getContentPane().add(font_panel);
     getContentPane().add(attribut_panel);
         getContentPane().add(filename_default);
   JPanel  pflow = new JPanel(new FlowLayout());
   
JPanel p1 = new JPanel(new GridLayout(1, 3, 10, 2));
    JButton btOK = new JButton("OK");
    ActionListener lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        m_option = JOptionPane.OK_OPTION;
        _master.setPreference(getAttributesDefaultXML());
        setVisible(false);
      }
    };
    btOK.addActionListener(lst);
    p1.add(btOK);
    JButton btSave = new JButton("Save");
    JButton btCancel = new JButton("Cancel");
    lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        m_option = JOptionPane.CANCEL_OPTION;
        setVisible(false);
      }
    };btCancel.addActionListener(lst);
    lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        try{
      PrintWriter ostream = new PrintWriter(new FileOutputStream("xmljava.conf"));
      WritePreference(ostream);
      ostream.flush();
          ostream.close();} catch (Exception ed) {};
    }
    };
    btSave.addActionListener(lst);
	
    /** bouton ok cancel **/
    
      p1.add(btSave);
    p1.add(btCancel);
    
      pflow.add(p1);
     addWindowListener(this);
  
    pack();
    getContentPane().add(pflow);
        pack();
}
public boolean getBoth(){return endingbalise.isSelected();}
public void setBoth(boolean b){ endingbalise.setSelected(b);}
public String getFont1(){return m_lstFontNameDefaultTreeText.getSelected();}
public String getFont2(){return m_lstFontNameDefaultTreeXml.getSelected();}
  public void setAttributes(AttributeSet a) {
    if (a==null) return;
    String name = StyleConstants.getFontFamily(a);  
    m_lstFontNameDefaultXML.setSelected(name);
  m_chkBoldDefaultXML.setSelected(StyleConstants.isBold(a));
    m_chkItalicDefaultXML.setSelected(StyleConstants.isItalic(a));
    m_chkUnderlineDefaultXML.setSelected(StyleConstants.isUnderline(a));
  
  }
  
 public SimpleAttributeSet getAttributesDefaultXML() {
    /*if (m_attributes == null)
      return null;*/
      SimpleAttributeSet result=new SimpleAttributeSet();
    StyleConstants.setFontFamily(result, 
      m_lstFontNameDefaultXML.getSelected());
    
    StyleConstants.setBold(result, 
      m_chkBoldDefaultXML.isSelected());
    StyleConstants.setItalic(result, 
      m_chkItalicDefaultXML.isSelected());
    StyleConstants.setUnderline(result, 
      m_chkUnderlineDefaultXML.isSelected());
   
    return result;
  }
 
 public void init()
 {
 dtdfile.setText(_master.getDTDFile());
 }
 public void windowActivated(WindowEvent e){init();} 
 public void windowClosed(WindowEvent e) {}
  public void windowClosing(WindowEvent e) {}
  public void windowDeactivated(WindowEvent e) {}
  public void windowDeiconified(WindowEvent e) {}
  public void windowIconified(WindowEvent e) {}
  public void windowOpened(WindowEvent e)  {init();}

  
public  void WritePreference(PrintWriter _writer)
{
SimpleAttributeSet attr=getAttributesDefaultXML();
Vector v=_master.GetDefaultColor();
_writer.print("<preference>\n");
for (int i=0;i<v.size();i++){
Color c=(Color)v.get(i);
int red=c.getRed();
int blue=c.getBlue();
int green=c.getGreen();
_writer.print("<"+color+" "+frontcolor_red+"=\""+red+"\" "+frontcolor_green+"=\""+green+"\" "+frontcolor_blue+"=\""+blue+"\" />\n");

}

_writer.print("<"+style_def+" "+font+"=\""+StyleConstants.getFontFamily(attr)+"\" ");
_writer.print(" "+underline+"=\""+StyleConstants.isUnderline(attr)+"\" "+bold+"=\""+StyleConstants.isBold(attr)+"\" ");
_writer.print(" "+italic+"=\""+StyleConstants.isItalic(attr)+"\" />\n"); 
_writer.print("<"+defaultdtdfile+" "+attribut_name+"=\""+dtdfile.getText()+"\" />\n");
_writer.print("<"+both+" "+attribut_value+"=\""+endingbalise.isSelected()+"\" />\n");



_writer.print("</preference>\n");

}
}
  